<script lang="ts">
  import SuitIcon from "./icons/SuitIcon.svelte";
  import { getRank, getSuit } from "../serverUtils";
  import { send, receive } from "./cardCrossfade";

  export let card: Card;

  $: suit = getSuit(card);
  $: rank = getRank(card);

  function getRankClass(suit: Suit): string {
    switch (suit) {
      case "W":
        return "white-suit";
      case "Y":
        return "yellow-suit";
      case "G":
        return "green-suit";
      case "B":
        return "blue-suit";
      case "R":
        return "red-suit";
    }
  }
</script>

<div in:receive={{ key: card }} out:send={{ key: card }}>
  <div class="wrapper shadow border">
    <div class="inner">
      <div class="corner">
        <div class={`rank ${getRankClass(suit)}`}>{rank}</div>
        <div class="suit">
          <SuitIcon {suit} />
        </div>
      </div>
    </div>
  </div>
</div>

<style>
  .wrapper {
    background-color: linen;
    position: relative;
    width: 10em;
    height: 14em;
    border-radius: 7% / 5%;
    border: 0.05em solid lightgray;
  }

  .inner {
    background: radial-gradient(#475ab1, #374997);

    border-radius: inherit;
    position: absolute;
    top: 5%;
    bottom: 5%;
    left: 7%;
    right: 7%;
  }

  .corner {
    margin-top: 0.25em;
    margin-left: 0.5em;
    width: 2em;
    text-align: center;
  }
  .rank {
    font-size: 2em;
    font-weight: 900;
  }
  .suit {
    width: 2em;
  }
  .white-suit {
    color: #ebebeb;
  }
  .yellow-suit {
    color: #fdd835;
  }
  .green-suit {
    color: #9ccd65;
  }
  .blue-suit {
    color: #6bd1ff;
  }
  .red-suit {
    color: #f0413d;
  }
</style>
